module ShapePicture_Editor exposing (main)
--Browser
import Browser
import Browser.Navigation as Nav
-- Url
import Url
-- Own
import TypeHolder exposing (Model, Msg(..))
import Manager.UpdateManager exposing (update)
import Manager.ViewManager   exposing (documentView)
import Manager.StateManager  as StM
import Util.Util exposing (Picture, isEdit)

main = Browser.application
        { init = init
        , subscriptions = subscriptions
        , update = update
        , view = documentView
        , onUrlChange = UrlChanged
        , onUrlRequest = LinkClicked
        }
-- INIT
init : () -> Url.Url -> Nav.Key-> (Model, Cmd Msg)
init _ url key =
    ( { state = StM.Standby
      , saved = []
      , svgShapeHover = 0
      , shapesLoadResult = (Ok " Init")
      , picture = { url= ( Url.Url
                              Url.Http
                              "www.informatik.uni-halle.de"
                              Nothing
                              "/im/1285058520_1381_00_800.jpg"
                              Nothing
                              Nothing
                           )
                  , w = 0
                  , h = 0
                  }
      , edit = (isEdit url)
      , url  = url
      , key  = key
      , errorString = ""
      , stringToShapes = "{\"pictureUrl\":\"https://i2-prod.mirror.co.uk/incoming/article9690209.ece/ALTERNATES/s1200/Namibia.jpg\",\"shapes\":[{\"shape\":{\"circle\":{\"cx\":\"50\",\"cy\":\"50\",\"r\":\"40\"}},\"shapeprop\":{\"hFC\":\"white\",\"hFO\":\"0.5\",\"hSC\":\"red\",\"hSW\":\"3\",\"hSO\":\"1.0\",\"uFC\":\"white\",\"uFO\":\"0.0\",\"uSC\":\"red\",\"uSW\":\"3\",\"uSO\":\"1.0\",\"title\":\"default\",\"body\":\"default\"}},{\"shape\":{\"rect\":{\"x\":\"100\",\"y\":\"100\",\"width\":\"50\",\"height\":\"60\"}},\"shapeprop\":{\"hFC\":\"white\",\"hFO\":\"0.5\",\"hSC\":\"red\",\"hSW\":\"3\",\"hSO\":\"1.0\",\"uFC\":\"white\",\"uFO\":\"0.0\",\"uSC\":\"red\",\"uSW\":\"3\",\"uSO\":\"1.0\",\"title\":\"default\",\"body\":\"default\"}},{\"shape\":{\"polygon\":[{\"x\":\"200\",\"y\":\"150\"},{\"x\":\"250\",\"y\":\"400\"},{\"x\":\"120\",\"y\":\"340\"},{\"x\":\"160\",\"y\":\"250\"},{\"x\":\"180\",\"y\":\"170\"}]},\"shapeprop\":{\"hFC\":\"white\",\"hFO\":\"0.5\",\"hSC\":\"red\",\"hSW\":\"3\",\"hSO\":\"1.0\",\"uFC\":\"white\",\"uFO\":\"0.0\",\"uSC\":\"red\",\"uSW\":\"3\",\"uSO\":\"1.0\",\"title\":\"default\",\"body\":\"default\"}}]}"
      }
    , Cmd.none
    )
-- SUBSCRIPTIONS
subscriptions : Model -> Sub Msg
subscriptions model = Sub.none